#ifndef _I386_MAGIC_H
#define _I386_MAGIC_H

#define BLOCK_SIZE 4096	// 4KB
#define POINTER_SIZE 4	// of analyzed system
#define INTEGER_SIZE 4	// of analyzed system
#define MB_4 4194304	// 4 MB
#define MB_1 1048576	// 1 MB

// MAGIC section...
// Linux specials

#define LINUX_MAGIC_PROCESS "kthread\0" 
// process, that should be found in all 2.6 running linuxes.
// Can be changed by parameter --magic-process

#define LINUX_MAGIC_USER_PROCESS "init\0"
// user process, that should be found in all 2.6 running linuxes.
// Can be changed by parameter --magic-user-process
// We need this, when looking for task_struct that is not in kernel context XXX WTF?


#define LINUX_MAGIC_MODULE "yenta_socket"
// module, that should be found in all 2.6 running linuxes.
//(if modules are enabled) I have not found module present on ALL systems, 
// propably you will need to specify this by parameter
// can be changed by parameter --magic-module


// Virtual Page Table (or PaGe Directory (PGD))
#define VPT_MAGIC_ADDR 0x00300000	// where to start looking for VPT
#define VPT_MAGIC_BS 4096	// size of block with VPT
#define VPT_MAGIC_COUNT 2000	// how many page to check, when looking for VPT
#define VPT_MAGIC_ZEROES 3072	// how many zeroes should be at the beggining of VPT

// ----- task_struct -----
#define TS_MAGIC_HEADLIST_NUMBER 9 
//10//distace in list_head occurances between in task_struct comm and tasks  :) 
// XXX add specification by parameter ? XXX
 
#define TS_MAGIC_HEADLIST_FRONT_NUMBER 5 //3 // Because backward search does not work good enough
#define TS_MAGIC_HEADLIST_SPREAD 3
// How far from TS_MAGIC_HEADLIST_FRONT_NUMBER to look for right list_head 
// (both sides,unit: list_heads;)
// See theoretical explaination for more information.

#define TS_MAGIC_MAX_TRIES 300 //200 //160		
// how many times try to find "tasks" inside task_struct..can vary!

#define TS_MAGIC_HL_MM_DST 6*POINTER_SIZE	
// distance from "tasks"	list_head to "mm" mmstruct...can vary!

#define TS_MAGIC_FILES_MAX_TRIES 100
// how many times try to find "files" inside task_struct

// ----- mm_struct -----
#define MM_MAGIC_PGD_DST 9*POINTER_SIZE
// distance from beginning of mm_struct to pgd variable...can vary!

// ----- module -----
#define MD_MAGIC_HEADLIST_NUMBER 1
// distace in list_head occurances between list_head and name in module struct :) 
// actualy not used, because they are just near
// XXX add specification by parameter ? XXX 

#define MD_MAGIC_MAX_TRIES 1
// how many times try to find "list" inside module..can vary!

#define MD_MAGIC_HL_NAME_DST 6*POINTER_SIZE	
// distance from "list" list_head to "name" in module...can vary!

// ----- qstr struct -----
#define QS_MAGIC_MAX_FILENAME_SIZE 512
// max. how long can be filename, when trying to list open files

// ----- dentry struct -----
#define DT_MAGIC_MAX_TRIES 100
// max. how many try to verify qstr inside dentry struct

// ----- vfs struct -----
#define VFS_MAGIC_MAX_TRIES 100	// max. how many try to verify devname inside vfs_struct
#define VFS_MAGIC_PATTERN  "/dev/"	// pattern we are looking for when verifying vfs_struct
#define VFS_MAGIC_PATTERN_LEN 5 // length of pattern when verifying vfs_struct

// ----- files_struct -----
#define FS_MAGIC_MAX_TRIES 100  //max. how many times try to fdt inside files_struct

// ----- fdtable struct -----
#define FD_MAGIC_MAX_TRIES 100  //max. how many times try to fdt inside fdtable_struct

// ----- file struct -----
#define FL_MAGIC_MAX_TRIES 100  //max. how many times try to fdt inside file_struct

#endif
