/*
 *             foriana
 * 
 *  FOrensic Ram Image ANAlyzer
 *  written in 2007 and 2008 by niekt0
 *  (niekt0@hysteria.sk, https://hysteria.sk/~niekt0)
 *  (please, mail me any discovered bugs/improvements.)
 * 
 * 
 *  version 0.3.0
 * 
 *  newest version at https://hysteria.sk/~niekt0/foriana
 * 
 *  Under GNU GPL.
 *  See http://gnu.org for more information.
 * 
 *  Use at your own risk.
 * 
*/


/* 2do:
 */

/* Limits of this version:
 */

#include "globals.h"
//#include "search.h"
#include <arch/i386/functions.h>


/*
 *  Global variables
 */


struct my_image image1;

char helpstatusfile[20]="foriana.cache";
char *statusfile2,*statusfile=helpstatusfile;
FILE *fs;	//cache file

char *inputfile;	//filename
int inputfd,statusfd;	//input & status output 
FILE *f;	//separate descriptor for searching in file

struct stat sbuffer;

char *errormsg;

char tmp_small_page[VPT_MAGIC_BS];
char MAGIC_MODULE[64]=LINUX_MAGIC_MODULE; // user can specify magic constants
char MAGIC_PROCESS[64]=LINUX_MAGIC_PROCESS; //-||-
char MAGIC_USER_PROCESS[64]=LINUX_MAGIC_USER_PROCESS; //-||-


int i,j,opt,mode=1,status=0;
unsigned long pointer;

int do_mod_list=0,do_mod_det=0,do_proc_det=0,do_proc_list=0; //for parsing cmdline options
int do_files_det=0,do_files_list=0,ignore_cache=0,ddebug=0; // -||-
//save here, which foriana funcionalities user requested

// Debug function
int debug(){
	int i;

	printf("--------- Begin of debug info ---------\n");
	printf("do_mod_list: %d,do_mod_det: %d,do_proc_det: %d,do_proc_list: %d,ignore_cache: %d\n",do_mod_list,do_mod_det,do_proc_det,do_proc_list,ignore_cache);
	printf("guest_block_size: %d\narchitecture: %s\noperating_system: %s\nVPT_address: %lx\nram_size: %llu\nts_hl_comm_dst: %d\nmd_hl_name_dst: %d\nts_one_of_lists: %lx\nts_hl_mm_dst: %d\nmm_pgd_dst: %d\n",
	image1.guest_block_size,	// size of block in analyzed image
	image1.architecture,	// hw architecture of analyzed image
	image1.operating_system,	// operation system if analyzed image
	image1.VPT_address,	// position of VPT (from beginig of file)
	image1.ram_size,	  // size of image in kilobytes
	image1.ts_hl_comm_dst,	  // distance between comm and headlist 
	image1.md_hl_name_dst,
	image1.ts_one_of_lists, // address of tasks list_head of one of taks_struct structures
	image1.ts_hl_mm_dst, // =TS_MAGIC_HL_MM_DST; // Distance from "tasks" list_head to "mm" mmstruct...can vary!
	image1.mm_pgd_dst); // =MM_MAGIC_PGD_DST;  //Distance from beginning of mm_struct to pgd variable...can vary!
	
	printf("ts_headlists_nuber:%d\n",image1.ts_headlists_number);
	for (i=TS_MAGIC_HEADLIST_MAX;i>=0;i--){
		printf("  Headlist number %d: %lx\n",i,image1.ts_headlists[i]);
	}
	
	printf("md_headlists_nuber:%d\n",image1.md_headlists_number);
	for (i=MD_MAGIC_HEADLIST_MAX;i>=0;i--){
		printf("  Headlist number %d: %lx\n",i,image1.md_headlists[i]);
	}
	printf("--------- End of debug info ---------\n");

	return 0;
}

/*
 * Function that saves gathered information into cachefile.
 * If you modify this function, don't forget to modify read_info too!
 * 
 */

int save_info(){
	int i;
	
	printf("Saving determined information to cache file. \n");

        if ( (fs = fopen(statusfile,"w")) == NULL ) {
		errormsg = strerror(errno);
		fprintf(stderr, "%s: %s.\n",statusfile,errormsg);
		return 22;
	}

	// So at this moment we have file open for writing

	
	i=fprintf(fs,"%d\n%s\n%s\n%lx\n%llu\n%d\n%d\n%lx\n%d\n%d\n%lx\n",
	image1.guest_block_size,	// size of block in analyzed image
	image1.architecture,	// hw architecture of analyzed image
	image1.operating_system,	// operation system if analyzed image
	image1.VPT_address,	// position of VPT (from beginig of file)
	image1.ram_size,	  // size of image in kilobytes
	image1.ts_hl_comm_dst,	  // distance between comm and headlist 
	image1.md_hl_name_dst,	// distance between name and headlist in module
	image1.ts_one_of_lists, // linear address of tasks list_head of one of taks_struct structures
	image1.ts_hl_mm_dst, // =TS_MAGIC_HL_MM_DST; // Distance from "tasks" list_head to "mm" mmstruct...can vary!
	image1.mm_pgd_dst, // =MM_MAGIC_PGD_DST;  //Distance from beginning of mm_struct to pgd variable...can vary!
	image1.md_one_of_lists); // linear address of module list_head of one of module structures
	
	i=fclose(fs);
	
	return i;
}

/*
 * Function that reads previously saved information from cachefile
 * If you modify this function, don't forget to modify save_info too!
 * 
 */

int read_info(){
	int i;

	printf("Looking for cache_file: \"%s\" ... ",statusfile);fflush(stdout);

        if ( (fs = fopen(statusfile,"r")) == NULL ) {
//		dbgprint("read_info: file does not exist.\n");fflush(stdout);
		return 1;	//file does not exists => we will perform determination
	}

	// So at this moment we have file open for reading

	
	i=fscanf(fs,"%d\n%s\n%s\n%lx\n%llu\n%d\n%d\n%lx\n%d\n%d\n%lx",
	&image1.guest_block_size,	// size of block in analyzed image
	image1.architecture,	// hw architecture of analyzed image
	image1.operating_system,	// operation system if analyzed image
	&image1.VPT_address,	// position of VPT (from beginig of file)
	&image1.ram_size,	  // size of image in kilobytes
	&image1.ts_hl_comm_dst,	  // distance between comm and headlist in task_struct
	&image1.md_hl_name_dst,	  // distance between name and headlist in module
	&image1.ts_one_of_lists, // address of tasks list_head of one of taks_struct structures
	&image1.ts_hl_mm_dst, // =TS_MAGIC_HL_MM_DST; // Distance from "tasks" list_head to "mm" mmstruct...can vary!
	&image1.mm_pgd_dst, // =MM_MAGIC_PGD_DST;  //Distance from beginning of mm_struct to pgd variable...can vary!
	&image1.md_one_of_lists); // linear address of module list_head of one of module structures

//	printf("read_info: elements: %d.\n",i);fflush(stdout);
	
	if (i != FORIANA_CACHE_SIZE){
		printf("read_info: %d elements: bad file format.\n",i);fflush(stdout);
		return 2;
	}	
	
	printf("ok.\n");
	return 0;
}


/* 
 * Initialization function
 *
 * return > 0 if error occure
 * otherwise 0
 */

int init(){

//	printf("Init,%d, %s\n",inputfd,inputfile);

	//open input file	
        if ( (inputfd = open(inputfile,O_RDONLY)) == -1 ) {
                errormsg = strerror(errno);
                fprintf(stderr, "%s: %s.\n",inputfile,errormsg);
                return 21;
        }

//	printf("Init2:,%d\n",inputfd);

	//Determine file size
	if ( fstat(inputfd,&sbuffer) == -1){
		fprintf(stderr, "%s: Cannot get file statistics.\n",inputfile);
		return 22;
	}

	image1.ram_size=sbuffer.st_size;

	strcpy(image1.architecture,"NULL");
	strcpy(image1.operating_system,"NULL");

	//Check if we can read image "header"
	if (image1.ram_size < MB_1){	
		fprintf(stderr, "%s: File is too small (<1MB). Are you sure it is a memory dump? If yes, please modify foriana source code.\n",inputfile);
		return 23;
	}
	
	printf("Dumped RAM size is %llu MB.\n",image1.ram_size/MB_1);
	
	return 0;

}

void help(){
	
	printf("\nforiana %s by niekt0@hysteria.sk\n",fversion);
	printf("Usage: foriana [options] RAM_image\n");
	printf("Options:\n");
	printf("  -a/--all : try to dump everything avaiable. Generaly not good idea.\n");
	printf("  -c/--cache <file> : specify cache file with already determined information\n");
	printf("  -d/--determine-only : only determine information about image, do not list anything\n");
	printf("  --determine-skip-processes : skip determination of process structure\n");
	printf("  --determine-skip-modules : skip determination of module structure\n");
	printf("  --determine-skip-files : skip determination of various file structures\n");
	printf("  -h/--help : secret option\n");

	printf("  -i/--ignore-cache : ignores stored cache, and force new determination\n");

	printf("  --list-modules : force listing of modules\n");
	printf("  --list-processes : force listing of processes\n");
	printf("  --list-files : (NOT IMPLEMENTED NOW) force listing of open files\n");
	printf("  --magic-module <name> : specify module name foriana is looking for (default: \"kthread\")\n");
	printf("  --magic-process <name> : specify process name foriana is looking for (default: \"yenta_socket\")\n");
	printf("  --magic-user-process <name> : specify process name foriana assumes first one (default: \"init\")\n");


	printf("  -m/--module <address> :(NOT IMPLEMENTED NOW) list all information about this module only\n");
	printf("  -p/--process <address> :(NOT IMPLEMENTED NOW) list all information about this process only\n");
	printf("  -v/--version : print version number\n");
}

int main(int argc, char **argv)
{	

	// get_parameters

	static struct option long_opts[]={
		{"all",0,0,'a'},    
		{"cache",1,0,'c'},    
		{"debug",0,0,248},
		{"determine",0,0,'d'},    
		{"determine-skip-processes",0,0,245},
		{"determine-skip-modules",0,0,246},
		{"determine-skip-files",0,0,247},
		{"help",0,0,'h'},
		{"ignore-cache",0,0,'i'},
		{"list-modules",0,0,240},
		{"list-processes",0,0,241},
		{"module",1,0,'m'},
		{"magic-module",1,0,242},
		{"magic-process",1,0,243},
		{"magic-user-process",1,0,244},
//		{"output",1,0,'o'}, // decided to use stdout instead 
		{"process",1,0,'p'},
//		{"specify",1,0,'s'},	//specify some advanced options
		{"version",0,0,'v'},
		{0,0,0,0}                             
	};



	while((opt = getopt_long(argc, argv, "ac:dhim:p:v",long_opts, &i)) != -1) {
//		printf("opt: %d\n",opt);
	  switch(opt) {
		case 'a': /*--all*/
//			if (do_mod_list < 0) {}   TODO parameter collisions
			if (!(do_mod_det < 0)) {do_mod_det = 1; }
			if (!(do_mod_list < 0)) {do_mod_list = 1;}
			if (!(do_proc_det < 0)) {do_proc_det = 1;}
			if (!(do_proc_list < 0)) {do_proc_list = 1;}
			//do_files_det = 1; //XXX not working right now
			//do_files_list = -1; //XXX not working right now
			break;
		case 'c': /*--cache*/
			statusfile = optarg;
			break;
		case 248: /*--debug*/
			ddebug=1;
			break;
		case 'd': /*--determine*/
			if (!(do_mod_det < 0)) {do_mod_det = 1;}
			if (!(do_proc_det < 0)) {do_proc_det = 1;}
			//do_files_det = 1; //XXX not working right now
			break;
		case 'h': help(); return 0; break;
		case 'i': ignore_cache=1; break;
		case 'm': mode = 2; /*XXX TODO*/ break;
//		case 'o': outputfile=optarg; break;
		case 'p': mode = 2; /*XXX TODO*/ break;
		case 240: /*list_modules*/
			 do_mod_list=1;
			break;
		case 241: /*list-processes*/
			do_proc_list=1;
			break;
		case 249: /*list-files*/
			do_files_list=0; //1 XXX TODO not working right now ;
			break;
		case 242: /*--magic-module*/  
			memcpy(MAGIC_MODULE,optarg,strlen(optarg)+1); //+1 because of \0
			printf("foriana %s\n",MAGIC_MODULE); //XXX DBG
			break;
		case 243: /*--magic-process*/
			memcpy(MAGIC_PROCESS,optarg,strlen(optarg)+1); //+1 because of \0
			printf("foriana %s\n",MAGIC_PROCESS); //XXX DBG
			break;
		case 244: /*--magic-user-process*/
			memcpy(MAGIC_USER_PROCESS,optarg,strlen(optarg)+1); //+1 because of \0
			break;
		case 245: /*--determine-skip-processes*/ 
			do_proc_det=-1; // Conflict flag
			//	do_mod_list=-1; // No listing without determination? 
			// It's less user-friendly, but allow you to modify cache file by hand.
			 break;
		case 246: /*--determine-skip-modules*/;
			do_mod_det=-1; // Conflict flag
			//	do_mod_list=-1; // No listing without determination? 
			// It's less user-friendly, but allow you to modify cache file by hand.
			 break;
		case 247: /*determine-skip-files*/
			do_files_det=-1; // Conflict flag
			//	do_mod_list=-1; // No listing without determination? 
			// It's less user-friendly, but allow you to modify cache file by hand.
			 break;

		case 'v': printf("foriana %s\n",fversion); return 0; break;
		case '?': fprintf(stderr, "Syntax error.\n"); help(); return 7; break;	
	  }   	
	}	

        if ((argv[optind] != NULL) && (argv[optind+1]==NULL)) {
                printf("Analyzing file %s\n",argv[optind]);
		inputfile = argv[optind];
        }else {
		fprintf(stderr, "Syntax error.\n"); 
		help();
		return 7;	
	}

	// parameter defaults
	
	/*
	 * Foriana check for cache file named "." + basename() of analysed image 
	 * inside working directory. If no cache file is found, new cache is
	 * created of this name. Name can be overridden with -c option.
	 *
	 */
	//dbgprint("statusfile0: %s\n",statusfile);fflush(stdout); //DBG
	if ( statusfile == helpstatusfile ) {	// cache file not specified

		if ( (statusfile2=strdup(inputfile) ) == NULL) {	//have to according to man 3 basename
			fprintf(stderr, "malloc() failed.\n");
			return 98;
		}	
		if ( (statusfile=malloc(strlen(inputfile)+1)) == NULL) { //ble...
			fprintf(stderr, "malloc() failed.\n");
			return 99;
		}

		sprintf(statusfile, ".%s", basename(statusfile2));
		free(statusfile2);
		//XXX free statusfile at the end?

	}

	// ----------------- program starts here ---------------------

	//Check size of input file & initialize
	if ((i = init()) != 0) {
		printf("Init returned %d. Exiting.\n",i);
		return 1;
	}


	if (ddebug == 1 ) {debug(); } //DBG
	fflush(stdout);
	//Determine information only if ignore_cache is not set,
	// or if cache file is missing or invalid
	if ((ignore_cache > 0) || ((i = read_info()) != 0))
	{
		if (ignore_cache > 0) {
			printf("Ignoring cache file.\n");
		}else{
                	printf("no valid cache found (err %d).\n",i);
		}
        	
		//Determine general information from image
		if ((i = i386_lin_determine()) != 0) {
	                printf("Determine returned %d. Exiting.\n",i);
	                return 2;
	        }

		if ( do_proc_det > 0 ) {
			if ((i = i386_lin_linux_determine()) != 0) {
                		printf("Linux_determine returned %d. Exiting.\n",i);
                		return 3;
			}
        	}

		if ( do_mod_det > 0 ) {
			if ((i = i386_lin_linux_determine_module()) != 0) {
        	       		printf("Linux_determine_module returned %d. Exiting.\n",i);
                		return 4;
        		}
		}

		if ( do_files_det > 0 ) {
		        if ((i = i386_lin_determine_open_files(image1.ts_one_of_lists)) != 0) {
				printf("i386_lin_determine_open_files returned %d. Exiting.\n",i);
				return 6;
			}
		}

		if ((i = save_info()) != 0) {
	                printf("save_info returned %d. Exiting.\n",i);
	                return 5;
	        }

		if (ddebug == 1 ) {debug(); } //DBG
	}
	fflush(stdout);

	//Listing stuff

	if ( do_proc_list > 0 ) {
		if ((i = i386_lin_list_processes(image1.ts_one_of_lists,image1.ts_hl_comm_dst)) != 0) {
        	        printf("Listed %d processes (hopefully).\n",i);
        	     //   return 4; //can fail
		}
        }

 	if ( do_mod_list > 0 ) {
		if ((i = i386_lin_list_modules(image1.md_one_of_lists,image1.md_hl_name_dst)) != 0) {
        	        printf("Listed %d modules (hopefully).\n",i);
	             //   return 4; //can fail
        	}
	}
	if (ddebug == 1 ) {debug(); } //DBG

	printf("Haven't found the lord, oh no no no.\n");
	//close output	
//	close(out_file);	
	return 0;

//----------------------------------------------------------------------------
//---------- Hard coded trash -----------------------
}
